// Counts word frequencies in input.
#include "Dict.h"
#include "Vector.h"

#include <algorithm>
#include <iostream>

using namespace std;
using namespace dictionary;

int main()
{
    Dict<string, unsigned> freqs;

    for (string word; cin >> word && word != "eof"; ) {
        ++freqs[word];
    }

    Vector<pair<unsigned, string>> freqs_sorted;

    for (const string& word : freqs.get_keys()) {
        freqs_sorted.push_back({freqs[word], word});
    }

    sort(begin(freqs_sorted), end(freqs_sorted));

    for (const pair<unsigned, string>& each : freqs_sorted) {
        cout << each.second << ": " << each.first << '\n';
    }
}
